///////////////////////////////////////////////////////////////////////////////
//
//
//				                   Watch-dog for UIDC
// 					                  ver 0.1
//					                      (2020)
//
//
//
///////////////////////////////////////////////////////////////////////////////











#include <sys/types.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <linux/fs.h>


char my_account[80];

int chk_pid_server(const char*process) {

     char rep[1024]="null";
     FILE*fp = popen(process,"r");
     if(fp==NULL) return 0;
     fgets(rep,1024,fp);
     pclose(fp);
     if(strcmp(rep, "null")==0) return 0;
     return 1;
}






int main(int argc, char **argv) {

  char st[500];	

  pid_t pid;
  printf("\n       --- Daemon sync time run ---\n\n");	


  if(argc!=2) return 0;

  strcpy(my_account, argv[1]);

  printf("   my account: %s\n\n",  my_account);
  int spid = chk_pid_server("pidof mserverUIDC");
  printf("   mserverUIDC %d\n\n", spid);
  

  //sprawdza czy daemon jest uruchamiany jako root
  if(getuid()!=0) {
		printf("\n  Login as root [1]\n"); 
		return 0;
		}



//		---------- DAEMON ----------

  // --- szkielet demona ---
  pid = fork();
  if(pid==-1) exit(EXIT_FAILURE);//return -1;
  else 
  if(pid!=0) exit(EXIT_SUCCESS);


  //nowa sesja
  if(setsid()==-1) return -1; 
  // --- zmiana katalogu roboczego aby przy odmotowaniu HDD nie bylo problemu
  // --- if(chdir("/")==-1) return -1;
  //zmiana katalogu roboczego
  strcpy(st, "/home/");
  strcat(st, my_account);
  strcat(st, "/UIDC-EXEC/CENTRAL_SERVER");
  system(st);
  if(chdir(st)==-1) return -1;

  //zamyka pliki
  close(STDIN_FILENO);
  close(STDOUT_FILENO);
  close(STDERR_FILENO);
  // --- Koniec szkieletu demona ---


  //--- tresc daemona ---
  while(1) {


	//sprawdza co 60s obecnosc mseerverUIDC i ewentualnie uruchamia 
	//demona mserverUIDC
	if( !chk_pid_server("pidof mserverUIDC") ) {
		strcpy(st, "/home/");
		strcat(st, my_account);
		strcat(st, "/UIDC-EXEC/CENTRAL_SERVER/start_server");
		system(st);
	}

   	sleep(60);
  	}
  //--- koniec tresci daemona ---


  return 0;
}
