///////////////////////////////////////////////////////////////////////////////
//
//			 Generator RSA liczb pseudolosowych
//				       JPW -lib
//				       ver  0.2
//				     (2017/2019)
//
//
///////////////////////////////////////////////////////////////////////////////



#include <stdio.h>
#include <stdint.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>


#define MAX_G_RSA 1000

unsigned int init_seed;


//-----------------------------------------------------------------------------
//------------------- mnozenie i modulo duzych liczb integer ------------------
//mnozy dwie bardzo dlugie liczby typu integers
char*multiply(char a[],char b[]){
    	static char mul[MAX_G_RSA];
    	char c[MAX_G_RSA];
    	char temp[MAX_G_RSA];
	int la,lb;
    	int i,j,k=0,x=0,y;
    	long int r=0;
    	long sum = 0;
    	la=strlen(a)-1;
        lb=strlen(b)-1;
    	    for(i=0;i<=la;i++) {
                a[i] = a[i] - 48;
    	    }
   	     for(i=0;i<=lb;i++) {
                b[i] = b[i] - 48;
      	    }
    	    for(i=lb;i>=0;i--) {
         	r=0;
      	    for(j=la;j>=0;j--) {
             	temp[k++] = (b[i]*a[j] + r)%10;
             	r = (b[i]*a[j]+r)/10;
   	    }
 	        temp[k++] = r;
	         x++;
	         for(y = 0;y<x;y++) {
   	          	temp[k++] = 0;
	         }
	    }
	    k=0;
	    r=0;
	    for(i=0;i<la+lb+2;i++) {
	         sum =0;
	         y=0;
	         for(j=1;j<=lb+1;j++) {
  	           	if(i <= la+j) {
	                 sum = sum + temp[y+i];
 	                }
	             y += j + la + 1;
  	        }
 	        c[k++] = (sum+r) %10;
	        r = (sum+r)/10;
	    }
	    c[k] = r;
	    j=0;
	    for(i=k-1;i>=0;i--) {
	         mul[j++]=c[i] + 48;
	    }
	    mul[j]='\0';
	    return mul;
}

//oblicza modulo dla long numbers
int mod(char*num, long long n) {
	if(n==0) return -1;
	int i;
	//int remainder = 0;
	long long remainder = 0;
	for (i = 0; num[i] != '\0'; ++i)
		remainder = (remainder * 10 + num[i] - '0') % n;
	return (int) remainder;
}

//------------ END mnozenie i modulo duzych liczb calkowitych -----------------
//-----------------------------------------------------------------------------


//-----------------------------------------------------------------------------
//------------------------------ Generator RSA --------------------------------

//--- ziarno Generatora RSA ---
void RSA_srand(unsigned int seed){
   init_seed = seed;
}

//--- RSA long generator ---
int RSA_rand() {
        char result[MAX_G_RSA];
   	char sinit[40];
   	char tmp[40];
   	sprintf(sinit,"%u",init_seed);
   	strcpy(tmp,sinit);
   	//char*result = (char*)malloc(1000*sizeof(char));
   	strcpy(result,sinit);
   	int i=0;
   for(;i<5;i++) {
      strcpy(tmp,sinit);
      strcpy(result,multiply(result,tmp));
   }
    //9929*27409
    //int n=272143961;
    long long n = 239582517375821; //15485653*15471257
    int ret = mod(result, n);
    //free(result);
    init_seed = (unsigned int) ret;
   return ret;
}
//----------------------------- END Generator RSA -----------------------------
//-----------------------------------------------------------------------------


